module SolvingDData(solveDData) where

import BasicData -- Definitions needed for introduce new data types 
                 -- 
import MyPrelude
import MoreMonad

import ResidualLang
import ResidualLangPrint
import SpecState
import SpecMonad

import PredsSimplify
import SolvingFailure

import List

solveDData forcing ftvs fsvs t delta =     
 do cswithdup <- whichConstructors t delta 
    let cs = nub cswithdup
    rdata <- createDData cs
    h <- freshevidence
    traceSM ("Creating DData with constructors "++show cs++":") t 
    simplifySolving ftvs fsvs ((h, Unify (RTVar t) rdata):delta)
  
-- Detect the constructor that data has. It travel by the all context 
whichConstructors t [] = return [] 
whichConstructors t ((_, d@(HasC td c tau)):delta) = 
   do td'<- indir td 
      cs <- whichConstructors t delta       
      case td' of 
           (RTVar tv) -> if tv == t then return (c:cs)
                            else return cs
           _ -> return cs
whichConstructors t ((_,_):delta) = whichConstructors t delta 


-- Add a Dynamic Data Type Definition based on the constructors 
-- detected
createDData cs = do (EVar n) <- freshevidence 
                                  -- it's a hack :)
                    let dname = "D_"++(show n)
                    constrs <- mapM (addConstructor n) cs
                    let d' = RDataDef dname [] [] [] constrs
                    addData d'
                    return (RTData dname [] []) 
                 where addConstructor n cname = 
                         do t <- freshresidualtype
                            return (Constructor (cname++"_"++(show n)) [t])
