module SolvingFailure where

import ResidualLang
import ResidualLangPrint
import SpecMonad

------
-- Fails if the predicates indicates so
------
checkFailure []               = return ()
checkFailure ((_,Fail msg):_) = fail msg
checkFailure (_:delta)        = checkFailure delta

noSolution forcing startmsg preds delta = 
 let msg = startmsg ++ ppresidualpredicates preds
                    ++ "\n in \n\n" 
                    ++ ppresidualpredicates delta
  in if forcing
      then fail msg
      else do h <- freshevidence
              let hs  = takeEvidence delta
              let vs  = [ h | _ <- hs ]
              return (hs,vs, [(h,Fail msg)])

msgNoSolution n = "There is no solution for this context (" ++ show n ++ "):\n"
msgAmbiguous  = "Ambiguous specialisation! \n" 

